/*
*	 カメラの ひな形2 複数のカメラ視点  main.c   
*                                       Tsukubado
 */
 
 #include <alleggl.h>
 #define GLYPH_TARGET GLYPH_TARGET_ALLEGGL
#include <glyph.h>
#include <allegro.h>
#include <math.h>

#ifdef ALLEGRO_MACOSX
#include <OpenGL/glu.h>
#else
#include <GL/glu.h>
#endif


 /* ############################################## */
/* カメラ */
double board=0;
struct camera {
	double xangle, yangle, zangle;
	double dist;
};

struct camera camera = {
	0.0, 0.0, 0.0,
	20.0
};

double angle_move = 5.0;
double dist_move = 1.0;
 
 /* ############################################## */
/* キーボード操作 */
void keyboard (void){
	if (key[KEY_LEFT]) camera.yangle += angle_move;
	if (key[KEY_RIGHT]) camera.yangle -= angle_move;

	if (key[KEY_UP]) camera.xangle += angle_move;
	if (key[KEY_DOWN]) camera.xangle -= angle_move;

	if (key[KEY_F]) camera.dist -= dist_move;
	if (key[KEY_R]) camera.dist += dist_move;
 

      /* 角度補正 */
     if ( camera.xangle < 0  ){ camera.xangle = 359; }
     if ( camera.yangle < 0  ){ camera.yangle = 359; }
	 if ( camera.xangle > 360 ){ camera.xangle = 0; }
     if ( camera.yangle > 360 ){ camera.yangle = 0; }
	 
}
 /* ############################################## */
/* カメラのセット(主観) */
void set_view (void){



     /* 射影変換モード変換の行列を有効にする */
 	glMatrixMode (GL_PROJECTION);
	 
     /* 行列を初期化 */
 	glLoadIdentity ();
	
	
     /*  透視法射影 glFrustum  正射影 glOrtho */
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1.0, 40.0);
	
	/* モデルビュー変換の行列を有効にする(xyz) */	
	glMatrixMode (GL_MODELVIEW);
	
     /* カメラ基本位置にセット(x,y,z) */
	glTranslatef (0, 0, -camera.dist);
	glRotatef (camera.xangle, 1, 0, 0);
	glRotatef (camera.yangle, 0, 1, 0);
	glRotatef (camera.zangle, 0, 0, 1);
	
	

}


 /* ############################################## */
/* カメラのセット2(三人称視点) */
void set_view2 (void){

      /* 射影変換モード変換の行列を有効にする */
 	glMatrixMode (GL_PROJECTION);
	 
     /* 行列を初期化 */
 	glLoadIdentity ();
	
	
     /*  透視法射影 glFrustum  正射影 glOrtho */
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1.0, 40.0);
	
	/* モデルビュー変換の行列を有効にする(xyz) */	
	glMatrixMode (GL_MODELVIEW);
	
     /* カメラ基本位置にセット 角度(x,y,z)=(89,315,-17) */
	glTranslatef (0, 0, -11 );
	glRotatef (89  , 1, 0, 0);
	glRotatef (315 , 0, 1, 0);
	glRotatef (-11 , 0, 0, 1);
	

}



 /* ############################################## */
/*  オブジェクトモデルのセット */
void display (void){


	
	//描画色
     glColor3f(1.0, 0.0, 1.0);

     //オブジェクト glBegin(三角形) 頂点を指定する。
		  glBegin(GL_TRIANGLE_FAN);				
				 glVertex3d(4, -4, 4);
				glVertex3d(0, -4, -4);
				glVertex3d(4, -4, -4);

		 glEnd();
	
	 glColor3f(0.5, 0.4, 0.7); //描画色
	 glCallList(1);	 
	

 /* -------------------------------------- */
/* XYZ 軸 */

     glColor3f(1.0, 1.0, 1.0);

		glBegin(GL_LINES);				
				glVertex3d(0,0,0);
				glVertex3d(0,0,2);	
				
				glVertex3d(0,0,0);
				glVertex3d(0,2,0);
				
				glVertex3d(0,0,0);
				glVertex3d(2,0,0);
		glEnd();
	
/*  Z */
		glBegin(GL_LINE_STRIP);				
				glVertex3d(-0.1 ,0.1 ,2);
				glVertex3d( 0.1 ,0.1 ,2);	
				glVertex3d(-0.1,-0.1 ,2);	
				glVertex3d (0.1,-0.1 ,2);
		glEnd();
/*  Y */
		glBegin(GL_LINES);	
				glVertex3d( 0    ,2.1   , 0.1 );
				glVertex3d( 0    ,2.0   ,  0 );
				
				glVertex3d( 0    ,2.1   ,-0.1 );	
				glVertex3d( 0    ,1.8   , 0.1);
		glEnd();
/* X */
		glBegin(GL_LINES);	
				glVertex3d( 2    , 0.1  , 0.06 );
				glVertex3d( 2    ,-0.1  ,-0.06 );
				
				glVertex3d( 2    , 0.1  ,-0.06 );		
				glVertex3d( 2    ,-0.1  , 0.06 );	

		glEnd();
	
 /* -------------------------------------- */

	
}

/* #################################################################  */
/*  常にカメラ行列に平行な ビルボード  */
void billboard(){
/*  ビルボードの拡大縮小(Z軸方向へ自由に移動) */

 if ( ( board >= -37) && key[KEY_A]){ glTranslatef (0, 0, -0.01);board -= 0.01;}
 if ( ( board <= 0) && key[KEY_S]){ glTranslatef (0, 0,+0.01);board += 0.01;}

// ビルボードの表示
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR); 
	glColor3f(0.8, 0.5, 0.5);  
    
	glCallList(2);
	 	    
 	glColor3f(1.0, 1.0, 0.58);  

	glBegin(GL_LINE_STRIP);				
				glVertex3d(-0.1*10 , 0.1*10 ,0);
				glVertex3d( 0.1*10 , 0.1*10 ,0);	
				glVertex3d(-0.1*10 ,-0.1*10 ,0);	
				glVertex3d (0.1*10 ,-0.1*10 ,0);
        glEnd();

}



void text_draw( GLYPH_REND *rend, GLYPH_TEXTURE *texture){ 
char  str[100];

	/* テキスト表示部分(ビルボード) */
	rend_set_text_color( rend, 255, 155, 194 );/* 色を指定する */
	gk_render_line_gl_utf8( texture ,"Hello!! World", 15 , 28 ); /*  Glyph Keeper によるテキスト描画 */

	rend_set_text_color( rend, 155 ,194 , 255 );
	sprintf(str,"Board; Z-Dist: %2.2f",board);/*数値→文字列 変換 */
	gk_render_line_gl_utf8( texture , str , 400 , 28);
	
	sprintf(str,"Camera X:%3.0f",camera.xangle);
	gk_render_line_gl_utf8( texture , str , 400 , 50);
	
	sprintf(str,"Y:%3.0f",camera.yangle);
	gk_render_line_gl_utf8( texture , str , 480 , 78);
	
	sprintf(str,"Z:%3.0f",-camera.dist);
	gk_render_line_gl_utf8( texture , str , 520 , 108);
	glDisable( GL_TEXTURE_2D );

}






 /* ############################################## */
/*  メイン */
int main(int argc, const char *argv[])
{

set_uformat(U_UTF8);
gk_library_init(); 

/* Allegro の初期化 */
	allegro_init();
	install_keyboard();
	install_mouse();
	install_timer();
	install_allegro_gl();

/* AllegroGL の初期化  */
	allegro_gl_clear_settings();
	allegro_gl_set (AGL_DOUBLEBUFFER, 1);
	allegro_gl_set (AGL_SUGGEST,  AGL_DOUBLEBUFFER );
   
	set_color_depth (32);
	if (set_gfx_mode( GFX_OPENGL_WINDOWED , 640, 400, 0, 0) < 0) {
		allegro_message ("Error setting OpenGL graphics mode:¥n%s¥n"
		                 "Allegro GL error : %s¥n", allegro_error, allegro_gl_error);
		return -1;
}


/* TrueType フォントの読み込みと レンダラの準備  */
   GLYPH_FACE *face;
   /* face = load_face_from_file( "mikachan.ttf", 0 );*/
    face = load_face_from_file( "/System/Library/Fonts/ヒラギノ角ゴ Pro W3.otf", 0 );
   
   GLYPH_REND *rend = create_renderer(face,0 );  
   if( !rend ) {
      allegro_message( "Renderer not created!¥n" );
      exit( -1 );
   }

	GLYPH_TEXTURE *texture; 
   rend_set_size_pixels( rend, 24, 24 );
   rend_set_hinting_default( rend );
   rend_set_text_color( rend, 255, 155, 194 );
   rend_set_text_alpha( rend, 205 );
   
   texture = gk_create_texture( rend, 32, 255 );
   gk_send_texture_to_gpu( texture );  /* テクスチャフォントデータをGPUに転送 */


/* ディスプレイリストの準備 (オブジェクトモデルのため)  */
/* 背景を 黒(R,G,B) =(0,0,0)に */
	clear_to_color(screen, makecol(0, 0, 0));
	glClearColor (0, 0, 0, 0);	
/*  ディスプレイリスト1(いつでも呼び出せる)	 */
   glNewList(1, GL_COMPILE);
		  glBegin(GL_QUADS);				
				glVertex3d(0, 0, 0);
				glVertex3d(4, 0, 0);
				glVertex3d(4, 4, 0);
				glVertex3d(0, 4, 0);

        glEnd();
   glEndList();	
	
/* ビルボード用のディスプレイリスト(いつでも呼び出せる) */
   glNewList(2, GL_COMPILE);
/* 常に カメラに並行 にするために Zの値 を 16にしておく */
		  glBegin(GL_QUADS);				
				glVertex3d(0, 0, 16);
				glVertex3d(4, 0, 16);
				glVertex3d(4, 4, 16);
				glVertex3d(0, 4, 16);
  
        glEnd();
   glEndList();		




 /*  ###############################  */
 /*  操作部分  */
 while (!key[KEY_ESC]){	
 
  /* RGB と Debth バッファをリセット */
  glViewport(0,0 ,640  ,400 );
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity(); /*  行列初期化  */
  	
	/* glViewport(0,0  , 640/2  ,400/2 ); */
	
	set_view(); /* 視点セット(カメラ行列)  */
	keyboard();  /*キーボード入力系統 */	



		glPushMatrix(); /* カメラ行列を退避 */
			display();      /*  3Dオブジェクトセット  */
		glPopMatrix(); /* カメラ行列を元に戻す	*/
	
	billboard();  /* ビルボード(カメラ行列) */
	 text_draw(rend,texture);

	glPushMatrix();	/*  重要 */



    /*  --------------------- */
    /*  別のカメラ  */
 
	glViewport( 640/2, 0, 640/2 ,400/2);
	glLoadIdentity(); /*  行列初期化  */
	set_view2(); /* 視点セット(カメラ行列 三人称視点)  */
    	glPushMatrix(); /* カメラ行列を退避 */
			display();      /*  3Dオブジェクトセット  */
		glPopMatrix(); /* カメラ行列を元に戻す	*/



	glPushMatrix();	/*  重要 */

	/*  --------------------- */

/*  フリップ表示 */
/* glFlush(); */
allegro_gl_flip();


rest(25);
  }

 /*  ###############################  */
 /*  メモリを開放 */
   gk_unload_texture_from_gpu( texture );
   gk_destroy_texture( texture ); 

return 0;
}
END_OF_MAIN();
